'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _YYClass = require('../base/YYClass');

var _YYClass2 = _interopRequireDefault(_YYClass);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var field = _YYClass2.default.field,
    PropTypes = _YYClass2.default.PropTypes;


var uiMeta = {
    name: 'yyui-layout',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'yyui-layout', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式')]
};

exports.default = _YYClass2.default.create({
    uiMeta: uiMeta,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames3.default)(prefixCls);
    },
    render: function render() {
        var className = this.props.className;

        var hasSider = false;
        if (_lodash2.default.isArray(this.props.children)) {
            this.props.children.map(function (item) {
                if (item.type.name === 'Sider' || item.type.displayName === 'Sider') {
                    hasSider = true;
                }
            });
        }

        var siderClass = (0, _classnames3.default)(_defineProperty({}, this.getClassName() + '-has-sider', hasSider));

        return _react2.default.createElement(
            'div',
            { className: (0, _classnames3.default)(this.getClassName(), siderClass, className) },
            this.props.children
        );
    }
});